
# HG changeset patch
# Parent  2dbbab94d4b60ae05cb2aebf5bad1b9e18cdbb11
Reset valid_flags to MODE_NONINTERACTIVE for sudoedit.
This is consistent with how the -e option is handled.
Also reject -H and -P flags for sudoedit as was done in sudo 1.7.
Found by Qualys.

Index: sudo-1.8.10p3/src/parse_args.c
===================================================================
--- sudo-1.8.10p3.orig/src/parse_args.c
+++ sudo-1.8.10p3/src/parse_args.c
@@ -23,6 +23,7 @@
 #include <sys/types.h>
 
 #include <stdio.h>
+#include <stdint.h>
 #ifdef STDC_HEADERS
 # include <stdlib.h>
 # include <stddef.h>
@@ -457,11 +458,14 @@ parse_args(int argc, char **argv, int *n
 	if (argc != 0) {
 	    /* shell -c "command" */
 	    char *src, *dst;
-	    size_t cmnd_size = (size_t) (argv[argc - 1] - argv[0]) +
-		strlen(argv[argc - 1]) + 1;
+	    size_t size = 0;
 
-	    cmnd = dst = emalloc2(cmnd_size, 2);
-	    for (av = argv; *av != NULL; av++) {
+	    for (av = argv; *av != NULL; av++)
+          size += strlen(*av) + 1;
+      if (size == 0 || size > SIZE_MAX/2 || (cmnd = realloc(NULL, size*2)) == NULL)
+       		fatalx(U_("%s: %s"), __func__, U_("unable to allocate memory"));
+
+    for (dst = cmnd, av = argv; *av != NULL; av++) {
 		for (src = *av; *src != '\0'; src++) {
 		    /* quote potential meta characters */
 		    if (!isalnum((unsigned char)*src) && *src != '_' && *src != '-' && *src != '$')
Index: sudo-1.8.10p3/plugins/sudoers/policy.c
===================================================================
--- sudo-1.8.10p3.orig/plugins/sudoers/policy.c
+++ sudo-1.8.10p3/plugins/sudoers/policy.c
@@ -85,6 +85,7 @@ extern char *login_style;
 int
 sudoers_policy_deserialize_info(void *v, char **runas_user, char **runas_group)
 {
+    const int edit_mask = MODE_EDIT|MODE_IGNORE_TICKET|MODE_NONINTERACTIVE;
     struct sudoers_policy_open_info *info = v;
     char * const *cur;
     const char *p, *errstr, *groups = NULL;
@@ -265,6 +266,12 @@ sudoers_policy_deserialize_info(void *v,
 	}
     }
 
+    /* Sudo front-end should restrict mode flags for sudoedit. */
+    if (ISSET(flags, MODE_EDIT) && (flags & edit_mask) != flags) {
+	    warningx(U_("invalid mode flags from sudo front end: 0x%x"), flags);
+   	  goto bad;
+    }
+
     for (cur = info->user_info; *cur != NULL; cur++) {
 	if (MATCHES(*cur, "user=")) {
 	    user_name = estrdup(*cur + sizeof("user=") - 1);
@@ -356,6 +363,9 @@ sudoers_policy_deserialize_info(void *v,
 
 #undef MATCHES
     debug_return_int(flags);
+
+bad:
+    debug_return_int(MODE_ERROR);
 }
 
 /*
Index: sudo-1.8.10p3/plugins/sudoers/sudoers.c
===================================================================
--- sudo-1.8.10p3.orig/plugins/sudoers/sudoers.c
+++ sudo-1.8.10p3/plugins/sudoers/sudoers.c
@@ -137,6 +137,8 @@ sudoers_policy_init(void *info, char * c
 
     /* Parse info from front-end. */
     sudo_mode = sudoers_policy_deserialize_info(info, &runas_user, &runas_group);
+    if (ISSET(sudo_mode, MODE_ERROR))
+	debug_return_int(-1);
 
     init_vars(envp);		/* XXX - move this later? */
 
@@ -221,7 +223,7 @@ sudoers_policy_main(int argc, char * con
     if (user_uid == 0 && !def_root_sudo) {
         warningx(U_("sudoers specifies that root is not allowed to sudo"));
         goto bad;
-    }    
+    }
 
     set_perms(PERM_INITIAL);
 
@@ -351,7 +353,7 @@ sudoers_policy_main(int argc, char * con
 
     /* If run as root with SUDO_USER set, set sudo_user.pw to that user. */
     /* XXX - causes confusion when root is not listed in sudoers */
-    if (sudo_mode & (MODE_RUN | MODE_EDIT) && prev_user != NULL) {
+    if (ISSET(sudo_mode, MODE_RUN|MODE_EDIT) && prev_user != NULL) {
 	if (user_uid == 0 && strcmp(prev_user, "root") != 0) {
 	    struct passwd *pw;
 
@@ -608,8 +610,8 @@ set_cmnd(void)
     if (user_cmnd == NULL)
 	user_cmnd = NewArgv[0];
 
-    if (sudo_mode & (MODE_RUN | MODE_EDIT | MODE_CHECK)) {
-	if (ISSET(sudo_mode, MODE_RUN | MODE_CHECK)) {
+  if (ISSET(sudo_mode, MODE_RUN|MODE_EDIT|MODE_CHECK)) {
+	if (!ISSET(sudo_mode, MODE_EDIT)) {
 	    if (def_secure_path && !user_is_exempt())
 		path = def_secure_path;
 	    set_perms(PERM_RUNAS);
@@ -634,18 +636,30 @@ set_cmnd(void)
 	    for (size = 0, av = NewArgv + 1; *av; av++)
 		size += strlen(*av) + 1;
 	    user_args = emalloc(size);
-	    if (ISSET(sudo_mode, MODE_SHELL|MODE_LOGIN_SHELL)) {
-		/*
+	    if (ISSET(sudo_mode, MODE_SHELL|MODE_LOGIN_SHELL) &&
+		    ISSET(sudo_mode, MODE_RUN)) {		/*
 		 * When running a command via a shell, the sudo front-end
 		 * escapes potential meta chars.  We unescape non-spaces
 		 * for sudoers matching and logging purposes.
 		 */
 		for (to = user_args, av = NewArgv + 1; (from = *av); av++) {
 		    while (*from) {
-			if (from[0] == '\\' && !isspace((unsigned char)from[1]))
+			if (from[0] == '\\' && from[1] != '\0' &&
+				!isspace((unsigned char)from[1])) {
 			    from++;
+			}
+			if (size - (to - user_args) < 1) {
+			    warningx(U_("internal error, %s overflow"),
+				__func__);
+			    debug_return_int(NOT_FOUND_ERROR);
+			}
 			*to++ = *from++;
 		    }
+		    if (size - (to - user_args) < 1) {
+			warningx(U_("internal error, %s overflow"),
+			    __func__);
+			debug_return_int(NOT_FOUND_ERROR);
+		    }
 		    *to++ = ' ';
 		}
 		*--to = '\0';
Index: sudo-1.8.10p3/plugins/sudoers/sudoers.h
===================================================================
--- sudo-1.8.10p3.orig/plugins/sudoers/sudoers.h
+++ sudo-1.8.10p3/plugins/sudoers/sudoers.h
@@ -133,6 +133,7 @@ struct sudo_user {
 #define FOUND                   0
 #define NOT_FOUND               1
 #define NOT_FOUND_DOT		2
+#define NOT_FOUND_ERROR	3
 
 /*
  * Various modes sudo can be in (based on arguments) in hex
@@ -147,6 +148,8 @@ struct sudo_user {
 #define MODE_LIST		0x00000080
 #define MODE_CHECK		0x00000100
 #define MODE_LISTDEFS		0x00000200
+/* Npte this is defined as 0x00000200 in later versions */
+#define MODE_ERROR		0x00000400
 #define MODE_MASK		0x0000ffff
 
 /* Mode flags */
Index: sudo-1.8.10p3/src/sudo_edit.c
===================================================================
--- sudo-1.8.10p3.orig/src/sudo_edit.c
+++ sudo-1.8.10p3/src/sudo_edit.c
@@ -55,6 +55,20 @@
 
 static char edit_tmpdir[MAX(sizeof(_PATH_VARTMP), sizeof(_PATH_TMP))];
 
+/*
+ * Directory open flags for use with openat(2).
+ * Use O_SEARCH/O_PATH and/or O_DIRECTORY where possible.
+ */
+#if defined(O_SEARCH)
+# define DIR_OPEN_FLAGS	(O_SEARCH|O_DIRECTORY)
+#elif defined(O_PATH)
+# define DIR_OPEN_FLAGS	(O_PATH|O_DIRECTORY)
+#elif defined(O_DIRECTORY)
+# define DIR_OPEN_FLAGS	(O_RDONLY|O_DIRECTORY)
+#else
+# define DIR_OPEN_FLAGS	(O_RDONLY|O_NONBLOCK)
+#endif
+
 static void
 switch_user(uid_t euid, gid_t egid, int ngroups, GETGROUPS_T *groups)
 {
